/*
 * vfilter can understand version strings
 *
 * Copyright (C) 2006 Jean-Philippe Guillemin <jp.guillemin@free.fr> and Thibaud Guerin <guth@ploposor.com>
 *
 * This file is free software; the copyright holder gives unlimited
 * permission to copy and/or distribute it, with or without
 * modifications, as long as this notice is preserved.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, to the extent permitted by law; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.
 */

#ifndef __VFILTER_H__
#define __VFILTER_H__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sysexits.h>
#include <linux/types.h>
#include <regex.h>


/*
#define VERSION "0.2"
#define TRUE 1
#define FALSE 0
#define EQUAL 0
#define LESSER -1
#define GREATER 1
*/

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

//#define DEBUG
#ifdef DEBUG
#define dbg(fmt,args...) fprintf(stderr, fmt , ## args)
#else
#define dbg(fmt,args...) do { } while (0)
#endif


#define BIG_BUFFER_SIZE 2024
#define MEDIUM_BUFFER_SIZE 256
#define TINY_BUFFER_SIZE 128
#define MICRO_BUFFER_SIZE 64

struct pkgfields
{
	char cat[BIG_BUFFER_SIZE];
	char *name;
	char softname[BIG_BUFFER_SIZE + 1 ];
	char version[BIG_BUFFER_SIZE + 1];
	char arch[MEDIUM_BUFFER_SIZE + 1];
	char build[BIG_BUFFER_SIZE + 1];
	char vserial[BIG_BUFFER_SIZE + 1 ];
	char bserial[BIG_BUFFER_SIZE + 1 ];
};


int getfields (struct pkgfields *pkg);

/* Transform homosapiens into Hal9000 style version string */
int serialize (struct pkgfields *pkg);

/* usage function */
int usage(void);

#endif
